/*
    Tucnak - VHF contest log
    Copyright (C) 2002-2004  Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#ifndef __SDLDYN_H
#define __SDLDYN_H

#define SDL_CreateRGBSurface(a,b,c,d,e,f,g,h) pSDL_CreateRGBSurface((a),(b),(c),(d),(e),(f),(g),(h))
#define SDL_CreateThread(a,b) pSDL_CreateThread((a),(b))
#define SDL_Delay(a) pSDL_Delay((a))
#define SDL_EnableKeyRepeat(a,b) pSDL_EnableKeyRepeat((a),(b))
#define SDL_EnableUNICODE(a) pSDL_EnableUNICODE((a))
#define SDL_FillRect(a,b,c) pSDL_FillRect((a),(b),(c))
#define SDL_FreeSurface(a) pSDL_FreeSurface((a))
#define SDL_GetModState() pSDL_GetModState()
#define SDL_GetRGB(a,b,c,d,e) pSDL_GetRGB((a),(b),(c),(d),(e))
#define SDL_GetVideoInfo() pSDL_GetVideoInfo()
#define SDL_Init(a) pSDL_Init((a))
#define SDL_ListModes(a,b) pSDL_ListModes((a),(b))
#define SDL_MapRGB(a,b,c,d) pSDL_MapRGB((a),(b),(c),(d))
#define SDL_PeepEvents(a,b,c,d) pSDL_PeepEvents((a),(b),(c),(d))
#define SDL_PumpEvents() pSDL_PumpEvents()
#define SDL_Quit() pSDL_Quit()
#define SDL_RWFromConstMem(a,b) pSDL_RWFromConstMem((a),(b))
#define SDL_RWFromFile(a,b) pSDL_RWFromFile((a),(b))
#define SDL_SetClipRect(a,b) pSDL_SetClipRect((a),(b))
#define SDL_SetColorKey(a,b,c) pSDL_SetColorKey((a),(b),(c))
#define SDL_SetColors(a,b,c,d) pSDL_SetColors((a),(b),(c),(d))
#define SDL_SetVideoMode(a,b,c,d) pSDL_SetVideoMode((a),(b),(c),(d))
#define SDL_UpdateRect(a,b,c,d,e) pSDL_UpdateRect((a),(b),(c),(d),(e))
#define SDL_UpperBlit(a,b,c,d) pSDL_UpperBlit((a),(b),(c),(d))
#define SDL_VideoDriverName(a,b) pSDL_VideoDriverName((a),(b))
#define SDL_WaitThread(a,b) pSDL_WaitThread((a),(b))
#define SDL_WM_SetCaption(a,b) pSDL_WM_SetCaption((a),(b))
#define SDL_WM_SetIcon(a,b) pSDL_WM_SetIcon((a),(b))

SDL_Surface * (*pSDL_CreateRGBSurface)(Uint32 flags, int width, int height, int depth, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask);
SDL_Thread * (*pSDL_CreateThread)(int (*fn)(void *), void *data);
void (*pSDL_Delay)(Uint32 ms);
int (*pSDL_EnableKeyRepeat)(int delay, int interval);
int (*pSDL_EnableUNICODE)(int enable);
int (*pSDL_FillRect)(SDL_Surface *dst, SDL_Rect *dstrect, Uint32 color);
void (*pSDL_FreeSurface)(SDL_Surface *surface);
SDLMod (*pSDL_GetModState)();
void (*pSDL_GetRGB)(Uint32 pixel, SDL_PixelFormat *fmt,	Uint8 *r, Uint8 *g, Uint8 *b);
const SDL_VideoInfo * (*pSDL_GetVideoInfo)();
int (*pSDL_Init)(Uint32 flags);
SDL_Rect ** (*pSDL_ListModes)(SDL_PixelFormat *format, Uint32 flags);
Uint32 (*pSDL_MapRGB)(SDL_PixelFormat *format, Uint8 r, Uint8 g, Uint8 b);
int (*pSDL_PeepEvents)(SDL_Event *events, int numevents, SDL_eventaction action, Uint32 mask);
void (*pSDL_PumpEvents)();
void (*pSDL_Quit)();
SDL_RWops * (*pSDL_RWFromConstMem)(const void *mem, int size);
SDL_RWops * (*pSDL_RWFromFile)(const char *file, const char *mode);
SDL_bool (*pSDL_SetClipRect)(SDL_Surface *surface, const SDL_Rect *rect);
int (*pSDL_SetColorKey)(SDL_Surface *surface, Uint32 flag, Uint32 key);
int (*pSDL_SetColors)(SDL_Surface *surface, SDL_Color *colors, int firstcolor, int ncolors);
SDL_Surface * (*pSDL_SetVideoMode)(int width, int height, int bpp, Uint32 flags);
void (*pSDL_UpdateRect)(SDL_Surface *screen, Sint32 x, Sint32 y, Uint32 w, Uint32 h);
int (*pSDL_UpperBlit)(SDL_Surface *src, SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect);
char * (*pSDL_VideoDriverName)(char *namebuf, int maxlen);
void (*pSDL_WaitThread)(SDL_Thread *thread, int *status);
void (*pSDL_WM_SetCaption)(const char *title, const char *icon);
void (*pSDL_WM_SetIcon)(SDL_Surface *icon, Uint8 *mask);

struct sdl;
int load_sdldyn(struct sdl *sdl);
void free_sdldyn(struct sdl *sdl);

#endif
